<?php
/**
 * AdminServiceProvider class.
 *
 * @package DokanKits\Core\DI\Providers
 * @since   3.0.0
 */

namespace DokanKits\Core\DI\Providers;

use DokanKits\Admin\Admin;
use DokanKits\Admin\Assets;
use DokanKits\Admin\Notices;
use DokanKits\Admin\Menu;
use DokanKits\Core\DI\BaseServiceProvider;

/**
 * Admin Service Provider
 */
class AdminServiceProvider extends BaseServiceProvider {

	/**
	 * Services provided by this provider
	 *
	 * @var array
	 */
	protected array $services = array(
		Admin::class,
		Assets::class,
		Menu::class,
		Notices::class,
	);

	/**
	 * Tags for this provider
	 *
	 * @var array
	 */
	protected array $tags = array( 'admin-service' );

	/**
	 * Register services with the container
	 *
	 * @return void
	 */
	public function register(): void {
		foreach ( $this->services as $service ) {
			$definition = $this->share_with_implements_tags( $service );
			$this->add_tags( $definition, $this->tags );
		}
	}
}
